Overview | Package | Class | Tree | Deprecated | Index | Help
| OracleAS PDK for Java 9.0.4.0.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.portal.provider.v2.personalize
Class DBPersonalizationManager

    java.lang.Object
      |
      +--oracle.portal.provider.v2.personalize.PortletPersonalizationManager
            |
            +--oracle.portal.provider.v2.personalize.DBPersonalizationManager

All Implemented Interfaces:
  Validateable

public class DBPersonalizationManager
extends PortletPersonalizationManager

The `DBPersonalizationManager` class implements a `PortletPersonalizationManager` using data objects to persist customized data in a database.

The class of the data objects managed by a `DBPersonalizationManager` is registered using `PortletPersonalizationManager.setDataClass(String)`. Most commonly this will be the result of a declaration in the provider XML registry (e.g. `<dataClass>className</dataClass>`). Your data class must implements the `PersonalizationObject` interface. It will be responsible for reading and writing its own content through its `read()` and `write()` methods. The framework includes an implementation of the `PersonalizationObject` interface that allows you to store data in terms of name/value pairs. You can use this or create your own implementation. The persisted data is stored in a database table; one row per customization. Connections to the database are retrieved from a 'pool', managed by the J2EE environment; therefore, you must ensure that you have configured an appropriate data source. In OC4J, this is done in the data-sources.xml file The name of the data source a DBPersonalizationManager will use to store customizations is specified using `setConnection(String)`. The name of the database table to be used to store customizations defaults to `JPDK_PREFERENCE_STORE`, but can be overriden with a call to `setTable(String)`. A table with this default name can be created in a database using the script in `providers/dbPersonalization/jpdk_preference_store.sql`. If a table of a different name is to be used, it must conform to the same design.

Constructor Summary
`DBPersonalizationManager()` Null Constructor

Method Summary
`void` | `copy(PortletReference from, PortletReference to, ProviderUser user)` Copies the instance customizations from one reference to another.
`void` | `create(PortletReference ref, PersonalizationObject o, ProviderUser user)` Creates the initial personalization reference for this (new) PortletReference.
`void` | `create(PortletReference ref, ProviderUser user)` Creates the initial personalization reference for this (new) PortletReference and establishes its (static) defaults.
`void` | `destroy(PortletReference ref, ProviderUser user)` Destroys a given Portlet instance from the repository by reference.
`void` | `destroy(ProviderInstance pi, PortletDefinition pd)` Called to allow the Portlet Personalization manager to destroy its repository.
`boolean` | `exists(PortletReference ref, ProviderUser user)` Returns true if a customization exists for this given reference.
`void` | `init(PortletDefinition p)` Initializes the repository for this `DBPersonalizationManager`.
`PersonalizationObject` | `read(PortletReference ref, ProviderUser user)` Returns a data object containing the customizations particular to this reference.
`void` | `setConnection(java.lang.String dataSourcePath)` Sets the path to the `DataSource` from which this `DBPersonalizationManager` should retrieve its database connections.
`void` | `setTable(java.lang.String tableName)` Sets the name of the database table in which this `DBPersonalizationManager` should store customization data.
`void` | `validate(java.lang.String context, ValidationError errors)` Validates the internal state of this `DBPersonalizationManager` instance.
`void` | `write(PortletReference ref, PersonalizationObject o, ProviderUser user)` Updates this reference's customization using the passed data object.

Methods inherited from class oracle.portal.provider.v2.personalize.PortletPersonalizationManager
`getDataClass, setDataClass`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DBPersonalizationManager

    public DBPersonalizationManager()
                             throws java.io.IOException

  Null Constructor

Method Detail

### setConnection

    public void setConnection(java.lang.String dataSourcePath)
                       throws java.io.IOException

  Sets the path to the `DataSource` from which this `DBPersonalizationManager` should retrieve its database connections.

  Parameters:
    `dataSourcePath` - JNDI path to a `DataSource` for a pooled database connection
  Throws:
    `java.io.IOException` - if a `DataSource` of the given name cannot be retrieved

### setTable

    public void setTable(java.lang.String tableName)

  Sets the name of the database table in which this `DBPersonalizationManager` should store customization data. If not set explicitly, the default name is `"JPDK_PREFERENCE_STORE"`.

  Parameters:
    `tableName` - name of the database table storing customization data

### init

    public void init(PortletDefinition p)

  Initializes the repository for this `DBPersonalizationManager`. This method is invoked on each of a Provider's PortletPersonalizationManagers whenever the Provider is registered on a Portal Node (when the Provider's `register()` method is called). This gives the personalization manager an opportunity to initialize the repository for the corresponding Portlet.

  The `DBPersonalizationManager` currently does nothing in response to this call.

  Specified by:
    `init` in class `PortletPersonalizationManager`
  Parameters:
    `p` - the portlet this `DBPersonalizationManager` is controlling.

### destroy

    public void destroy(ProviderInstance pi,
                        PortletDefinition pd)
                 throws AccessControlException,
                        java.io.IOException

  Called to allow the Portlet Personalization manager to destroy its repository. This method is called each time a Provider that manages this PortletPersonalizationManager's Portlet is deregistered (from a portal).

  In response to this call, the `DBPersonalizationManager` removes all rows from the database table that pertain to this Portlet.

  Specified by:
    `destroy` in class `PortletPersonalizationManager`
  Parameters:
    `pi` - the provider instance that is being deregistered.
    `pd` - the portlet this PortletPersonalizationManager is controlling. From the Portlet you can get the Provider to identify the specific instance going away.
    `AccessControlException`
    `java.io.IOException`

### create

    public void create(PortletReference ref,
                       ProviderUser user)
                throws java.io.IOException,
                       PortletAlreadyExistsException,
                       AccessControlException

  Creates the initial personalization reference for this (new) PortletReference and establishes its (static) defaults.

  In response to this call, the `DBPersonalizationManager` creates a new instance of the data object class that is registered to it, and calls its `init()` method. Finally, a default row for the instance is created in the database table, ensuring the initial data persists.

  Specified by:
    `create` in class `PortletPersonalizationManager`
  Parameters:
    `ref` - the PortletReference. The details of the PortletReference determine whether this creates the default, system instance or a specific user instance.
    `user` - the user attempting this operation. The manager is expected to authorize the user before completing this operation.
    `java.io.IOException`
    `PortletAlreadyExistsException`
    `AccessControlException`

### create

    public void create(PortletReference ref,
                       PersonalizationObject o,
                       ProviderUser user)
                throws PortletAlreadyExistsException,
                       AccessControlException,
                       java.io.IOException

  Creates the initial personalization reference for this (new) PortletReference. The initial data object representing this new instance is passed as a parameter.

  In response to this call, the `DBPersonalizationManager` saves the passed object to a row in the database table, ensuring the initial data persists.

  Specified by:
    `create` in class `PortletPersonalizationManager`
  Parameters:
    `ref` - the PortletReference. The details of the PortletReference determine whether this creates the default, system instance or a specific user instance.
    `o` - the PersonalizationObject representing the initial values for this instance.
    `user` - the user attempting this operation. The manager is expected to authorize the user before completing this operation.
    `PortletAlreadyExistsException`
    `AccessControlException`
    `java.io.IOException`

### exists

    public boolean exists(PortletReference ref,
                          ProviderUser user)
                   throws AccessControlException

  Returns true if a customization exists for this given reference. This will be true if a create() has been previously called.

  Specified by:
    `exists` in class `PortletPersonalizationManager`
  Parameters:
    `ref` - the portlet instance to check
    `user` - the user making this request -- passed to give the manager access the the session.
    `AccessControlException`

### read

    public PersonalizationObject read(PortletReference ref,
                                      ProviderUser user)
                               throws PortletNotFoundException,
                                      AccessControlException,
                                      java.io.IOException

  Returns a data object containing the customizations particular to this reference. If no customizations exist then the `PortletNotFoundException` is thrown.

  Specified by:
    `read` in class `PortletPersonalizationManager`
  Parameters:
    `ref` - the portlet reference that identifies the instance whose customizations are being requested.
    `user` - the user attempting this operation. The manager is expected to authorize the user before completing this operation.
  Returns:
    an Object (of the class specified with `setDataClass`) containing the customizations particular to this reference
  Throws:
    `PortletNotFoundException` - if no customizations exist
    `AccessControlException`
    `java.io.IOException`

### write

    public void write(PortletReference ref,
                      PersonalizationObject o,
                      ProviderUser user)
               throws java.io.IOException,
                      PortletNotFoundException,
                      AccessControlException

  Updates this reference's customization using the passed data object.

  Specified by:
    `write` in class `PortletPersonalizationManager`
  Parameters:
    `ref` - the portlet reference that identifies the instance whose customizations are being updated.
    `o` - the data object containing the new values (should implement PersonalizationObject).
    `user` - the user attempting this operation. The manager is expected to authorize the user before completing this operation.
    `java.io.IOException`
    `PortletNotFoundException`
    `AccessControlException`

### destroy

    public void destroy(PortletReference ref,
                        ProviderUser user)
                 throws PortletNotFoundException,
                        AccessControlException,
                        java.io.IOException

  Destroys a given Portlet instance from the repository by reference. If the reference refers to the system (default) instance the manager should additionally delete all user customizations that correspond.

  Specified by:
    `destroy` in class `PortletPersonalizationManager`
  Parameters:
    `ref` - the portlet reference that identifies the instance whose customizations are being deleted.
    `user` - the user attempting this operation. The manager is expected to authorize the user before completing this operation.
    `PortletNotFoundException`
    `AccessControlException`
    `java.io.IOException`

### copy

    public void copy(PortletReference from,
                     PortletReference to,
                     ProviderUser user)
              throws PortletNotFoundException,
                     AccessControlException,
                     java.io.IOException

  Copies the instance customizations from one reference to another. If the reference refers to the system (default) instance the manager should additionally copy any other corresponding default customizations for different locales. If the customization for the to reference doesn't exist it is created else the current values are overwritten.

  Specified by:
    `copy` in class `PortletPersonalizationManager`
  Parameters:
    `from` - reference for the portlet instance we are copying from.
    `to` - reference for the portlet instance we are copying to.
    `user` - the user attempting this operation. The manager is expected to authorize the user before completing this operation.
    `PortletNotFoundException`
    `AccessControlException`
    `java.io.IOException`

### validate

    public void validate(java.lang.String context,
                         ValidationError errors)

  Validates the internal state of this `DBPersonalizationManager` instance. Errors found are reported using the supplied `ValidationError` instance.

  Specified by:
    `validate` in interface `Validateable`
  Overrides:
    `validate` in class `PortletPersonalizationManager`
  Parameters:
    `context` - The context of the calling instance.
    `errors` - The current list of errors.

Overview | Package | Class | Tree | Deprecated | Index | Help
| OracleAS PDK for Java 9.0.4.0.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2002,2003 Oracle Corporation. All Rights Reserved.